class Editor.EditorModule.DockModule.ElementBay.Boards extends Backbone.View
  tagName: 'div'
  className: 'boards ui-tabs-vertical ui-helper-clearfix'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @labels = new Editor.EditorModule.DockModule.ElementBay.Labels({
      parent: this
    })
    @listenTo(@labels, 'sorted', @sorted)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@labels.render().$el)
    this
  
  add_element_tab: (tab) ->
    tab.label.render()
    tab.body.render()
    @labels.render()
    this.$el.append(tab.body.$el)
  
  sorted: () ->
    # data-z copy to model
    @trigger('sorted')
  
class Editor.EditorModule.DockModule.ElementBay.Labels extends Backbone.View
  tagName: 'ul'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
  
  render: () ->
    this.$el.html('')
    this.$el.addClass('inner-elements-tabs')
    _this = this
    _.each @zorderd_labels(), (label) =>
      this.$el.append(label.$el)
      if label.element()
        label.$el.mouseover -> 
          label.element().trigger('active')
        label.$el.mouseout -> 
          label.element().trigger('inactive')
        if label.destroy_button
          label.destroy_button.render()
    this.$el.sortable {
      update: (event, ui) ->
        _this.reorder()
        _this.trigger('sorted')
    }
    this
  
  zorderd_labels: () ->
    res = []
    _.each @bay().tabs, (tab) =>
      res[tab.label.z()] = tab.label
    res
  
  bay: () ->
    @parent.parent
  
  reorder: () ->
    z = 0
    $('li', this.$el).map ->
      $(@).attr('data-z', z)
      z++
  
