class Pettanr.Views.Balloon.Summary extends Pettanr.Views.Common.Summary
  
  initialize: (options) ->
    super(options)
    @item = options.item
    retriever = @item.speech_balloon()
    @listenTo(retriever, 'retrieve', @retrieve_speech_balloon)
    retriever.retrieve()
  
  retrieve_speech_balloon: (@speech_balloon) ->
    retriever = @speech_balloon.panel()
    @listenTo(retriever, 'retrieve', @retrieve_panel)
    retriever.retrieve()
  
  retrieve_panel: (@panel) ->
    @panel_icon = new Pettanr.Views.Common.Icon({item: @panel, half: true})
    @listenTo(@panel_icon, 'click', @panel_click)
    retriever = @panel.author()
    @listenTo(retriever, 'retrieve', @retrieve_author)
    retriever.retrieve()
  
  retrieve_author: (@author) ->
    @author_icon_with_caption = @author.icon_with_caption_view(true, 'name', 12)
    @listenTo(@author_icon_with_caption, 'click', @author_click)
    @trigger('ready')
  
  render: () ->
    this.$el.html('')
    this.$el.append(@panel_icon.render().el)
    this.$el.append(@author_icon_with_caption.render().el)
    this
  
  panel_click: () ->
    @trigger('http_get', @panel_icon.url())
  
  author_click: () ->
    @trigger('http_get', @author_icon_with_caption.url())
  
