class Pettanr.Views.OriginalPicture.Form extends Locmare.Form
  
  initialize: (options) ->
    super(options)
  
  render: () ->
    super()
  
  form_attr: () ->
    _.extend(super(), {
      enctype: 'multipart/form-data'
    })
  
  init_fields: () ->
    _.each @manifest.field_names, (field_name) =>
      field_manifest = @manifest.fields[field_name]
      @fields[field_name] = new Locmare.FormModule.Field({
        form: this, 
        field_name: field_name, 
        field_manifest: field_manifest
      })
  
  save: () ->
    @listenTo(@item, 'save:success', @success)
    @listenTo(@item, 'save:fail', @fail)
    form_data = new FormData(this.$el.get(0))
    attrs = {}
    _.each @fields, (field) =>
      if field.field_manifest.tag.type == 'file'
        form_data.append('original_picture[file]', field.tag.$el[0].files[0])
      else
        form_data.append(field.field_name, field.val())
    options = {
      data: form_data,
      processData: false,
      contentType: false
    }
    @item.save(null, {}, options)
  
