#原画
class OriginalPicturesController < ApplicationController
  before_filter :authenticate_reader, :only => [:show, :history]
  before_filter :authenticate_user, :only => [:index, :new, :edit, :create, :update, :destroy]
  before_filter :authenticate_artist, :only => [:index, :new, :edit, :create, :update, :destroy]
  
  def index
    filer_list
  end

  def show_html_format format
    format.html {
      #ライセンス付与のために原画ライセンスグループ作成準備
      @original_picture_license_group  = OriginalPictureLicenseGroup.new :original_picture_id => @item.id
      render
    }
  end
  
  def show_json_format format
    format.json { render json: @item.to_json(
      {:include => {:resource_picture => {}} }
    )}
  end
  
  def show
    set_show
    respond_to do |format|
      opt = {:type => @item.mime_type, :disposition=>"inline"}
      format.png { send_data(@item.restore(params[:subdir]), opt ) }
      format.gif { send_data(@item.restore(params[:subdir]), opt ) }
      format.jpeg { send_data(@item.restore(params[:subdir]), opt ) }
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end

  def history
    set_show
    @history = @item.history
    
    respond_to do |format|
      format.html
      format.json { render json: @history.to_json }
    end
  end
  
  def new
    set_new
    respond_to do |format|
      format.html
      format.json { render json: @item.to_json }
    end
  end
  
  def edit
    set_edit
    respond_to do |format|
      format.html
      format.json { render json: @item.to_json }
    end
  end
  
  def create
    set_model
    p  params[:file]
    @imager = if params[:original_picture]
      PettanImager.load set_image params[:original_picture][:file]
    else
      nil
    end
    @item = OriginalPicture.new
    @item.supply_default
    @item.overwrite @operators
    
    respond_to do |format|
      if @item.store(@imager)
        created_html_format format
        created_json_format format
      else
        not_created_html_format format
        not_created_json_format format
      end
    end
  end
  
  def update
    set_model
    @imager = if params[:original_picture]
      PettanImager.load set_image params[:original_picture][:file]
    else
      nil
    end
    @item = OriginalPicture.edit(params[:id], @operators)
    @item.overwrite @operators
    
    respond_to do |format|
      if @item.store(@imager)
        updated_html_format format
        updated_json_format format
      else
        not_updated_html_format format
        not_updated_json_format format
      end
    end
  end
  
  def destroy
    @item = OriginalPicture.edit(params[:id], @operators)
    
    respond_to do |format|
      if @item.destroy_with_resource_picture
        format.html { redirect_to original_pictures_url }
        format.json { head :ok }
      else
        format.html { redirect_to original_picture_path(@item) }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end
end
