class WritingFormatsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_filter :authenticate_user, :only => []
  else
    before_filter :authenticate_reader, :only => [
      :index, :by_system_picture, :show
    ]
    before_filter :authenticate_user, :only => []
  end
  before_filter :authenticate_admin, :only => [:new, :create, :edit, :update, :destroy]
  
  def index
    filer_list
  end
  
  def by_system_picture
    filer_list
  end
  
  def show_html_format format
    format.html {
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default 
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite 
    render_create
  end
  
  def update
    set_edit
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite 
    render_update
  end
  
  def destroy
    @item = self.class.model.edit(params[:id], @operators)
    respond_to do |format|
        flash[:notice] = I18n.t('flash.notice.not_destroyed', :model => self.class.model.model_name.human)
        format.html { redirect_to @item }
        format.json { render json: @item.errors, status: :unprocessable_entity }
    end
  end
  
end
