module Editor
  module EditorModule
    module DockModule
      class ScenarioBay < BoardBay
        def initialize parent, index, name
          super
          
          self.elements.each_with_index do |element, i| 
            tab = ScenarioBoard.new(self, i, element.item_name, element)
            add_tab tab, ScenarioBoardLabel.new(tab, element.item_name), 
              ScenarioBoardBody.new(tab)
          end
        end
        
        def elements
          self.root_item.scenario_elements
        end
        
        def class_name
          "tsort-box"
        end
        
      end
      
      module TabModule
        class ScenarioBayLabel < BayLabel
        end
        
        class ScenarioBayBody < BayBody
          def template_file_name
            'scenario'
          end
          
        end
        
      end
    end
  end
end
