ManifestBase.require_modules "local_manifest/list_group/list/", 
  %w|includes|

module LocalManifest
  module ListGroupModule
    module ListModule
      class Base < ManifestBase::TypeNameArgs
        attr :wheres, :includes
        
        def set_default
          super
          @args['includes'] ||= {}
        end
        
        def init
          super
          @wheres = @args['wheres'] || (self.model.content? ? ['index', 'public'] : ['index'])
          @includes = ManifestBase.load_type_args self, @args, 'includes', IncludeFactory
        end
        
        def model_manifest
          ::Manifest.manifest.models[self.item_name]
        end
        
        def model
          ::Manifest.item_name_to_model self.item_name
        end
        
        def item_name
          self.action_manifest.item_name
        end
        
        def action_manifest
          c = ::Manifest.manifest.controllers[self.controller_name]
          c.actions[self.action_name]
        end
        
        def action_name
          @name
        end
        
        def controller_name
          @parent.controller_name
        end
        
        def list_group
          @parent
        end
        
      end
    end
  end
end
