module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module SymbolItemColumnModule
            module DefaultModule
              module LinkModule
                class BaseLink
                  attr :default_symbol, :link_manifest, :item
                  def initialize default_symbol, link_manifest, item
                    @default_symbol = default_symbol
                    @link_manifest = link_manifest
                    @item = item
                  end
                  
                  def url
                    raise "undefined url\n"
                  end
                  
                end
                
                class ActionLink < BaseLink
                  
                  def url
                    controller_manifest = @item.class.my_controller
                    action_manifest = controller_manifest.actions[@link_manifest.action_name]
                    action_manifest.url({'id' => @item.id.to_s})
                  end
                end
                
                class NoneLink < BaseLink
                  
                  def url
                    nil
                  end
                  
                end
                
                class UrlColumnLink < BaseLink
                  
                  def url
                    @item.attributes[@link_manifest.column_name]
                  end
                  
                end
                
              end
            end
          end
        end
      end
    end
  end
end
