module Locmare
  module ListGroupModule
    class FilterList < Base
      attr :filter_key, :filter_item_name
      
      def init
        @filter_key = @list_manifest.filter_key
        @filter_item_name = @list_manifest.filter_item_name
        @filter_model = ::Manifest.manifest.models[@filter_item_name].classify
        @filter_table_name = @filter_model.table_name
        super
      end
      
      def filter_list_where
        [@table_name + '.' + @filter_key + ' = ?', self.filter_id] 
      end
      
      def include_hash
        w = super
        w.merge!({@filter_item_name => {} }) unless w[@filter_item_name]
        w
      end
      
      def visible?
        r = nil
        begin
          r = @filter_model.show(self.filter_id, @operators)
        rescue ActiveRecord::RecordNotFound, ActiveRecord::Forbidden
          r = false
        end
        r
      end
      
    end
    
  end
end
