require_dependency "locmare/profiler/column/extend/extend_column"
module Locmare
  module ProfilerModule
    module ColumnModule
      class Extend < Base
        include ExtendModule
        
        attr :columns
          
        def initialize profiler, column_manifest
          super
          
          @columns = {}
          self.extend_settings.column_names.each {|extend_column_name|
            extend_column_manifest = self.extend_settings.columns[extend_column_name] || {}
            @columns[extend_column_name] = ExtendColumn.new self, extend_column_name, extend_column_manifest
          }
        end
        
        def extend_columns
          self.extend_settings.column_names.map do |column_name|
            @columns[column_name]
          end
        end
        
        def extend_settings
          self.template_model_profiler.extend_settings[self.booster.item_name]
        end
        
        def template_model_profiler
          LocalManifest.manifest.profilers[self.template_model.item_name]
        end
        
        def template_model
          self.booster.template_model
        end
        
        def extend_item
          self.booster.extend_item
        end
        
        def booster
          self.item.boosters[@column_manifest.boost_name]
        end
        
        def template_file_name
          "extend"
        end
        
      end
    end
  end
end
